% Scabarの利用手引き


わかりにくい部分だけ説明します。


## 目次

<div class="menu">
[1 起動しなくなったとき](#reset)
[2 移動・リサイズ・回転の操作方法](#transform)
[3 スケールバー](#scalebar)
[4 ウォーターマーク(画像)](#watermark)
[5 自動バックアップ](#autobackup)
[6 その他](#tips)
</div>


<div class="menu">
[iPhoneでの注意など](iphone-ja.html)
[Androidでの注意など](android-ja.html)
[Windows/Macでの注意点など](pc-ja.html)
</div>


----



## 1 起動しなくなったとき {#reset}

初期化ツールを試してみてください。
Scabarの設定は消えてしまいます。

<div class="menu">
[初期化ツール](scabar-reset.html)
</div>



## 2 移動・リサイズ・回転の操作方法 {#transform}

まずメニューから専用のモードに入ってください。
例えばウォーターマークの場合はTool→WaterMark(Text)→Move/Resize

### マウスとキーボードの場合

* マウスホイールでリサイズ
* alt,shift,ctrl,metaキーのいずれかとマウスホイールで回転

OSやブラウザによって、なんらかの機能が割り当てられていると使えません。
shiftがどれでも使えそうです。


### タッチデバイスの場合

* 1本指でスクロール
* ピンチでリサイズ・回転




## 3 スケールバー {#scalebar}

### 自動挿入

現在対応しているのはTG-5他一部だけです(下記)。

画像編集ソフトを通した場合必要な失われるので、
直接撮影したjpeg画像を指定してください。
Olympus ViewerでRaw画像を現像した場合は大丈夫でした。

* メニューからTool→FOV
* 一番上のスイッチをオン(右側)にしてください。

条件によって精度が得られない場合があります。

* 遠い
* 広角
* ピントが合ってない
* 斜めになっている。

TG-5の望遠側で30cmくらいにとどめておいたほうが良いかもしれません。

FOVのスイッチは画像ファイルを開くたびにオフにしています。
面倒ですが毎回この操作を行ってください。


#### 対応機種

* TG-5 

あと使っている人はほとんどいないかもしれませんが...

* FourThirds + ZD 35mm F3.5 macro
* FourThirds + ZD 35mm F3.5 macro + TC-14
* M.FourThirds + MZD 75-300mm F4.8-6.7 + Raynox DCR-250



### マニュアルでの指定

FOVが判明している場合はマニュアルで指定することができます。

* Tool→FOV→Method→long sideを選ぶ。
* Dimensionを'36mm'のように単位付きで入力する。'µm'の場合は'um'が使えます。

~~FOVはイメージセンサーの横幅に対するオブジェクト面の幅です。
オリエンテーションとクロッピングは関係しません。
例えば35mmフルサイズのカメラに等倍で撮影した場合は、
36mmを入力してください。
デジタルズームは関係します。
上の条件でデジタルズーム2倍の場合は18mmを指定してください。~~

間違ってました。FOVは画像の横幅に対するオブジェクト面の幅です。
オリエンテーション(カメラを縦に構えたときに画像が回転する)には関係しません。

※メニューの字面どおり長い方の辺にした方がわかりやすいか。



## 4 ウォーターマーク(画像) {#watermark}

いろいろなフォーマットの画像(PNG,GIF,JPEG,SVG等)を使うことが出来ます。


### 4.1 jpegなど透明度を表せない形式

ウォーターマーク画像がモノクロで良い場合、
黒い部分(明度が低い)を透明にする機能を使って、
背景を透明にできます。
ウォーターマーク画像の背景を黒、前景を白で画像を作ってください。
Scabarに画像を取り込んだ後、
'Make Alpa'オプションで'Britness to Alpha Channel'
を選んでください。
そうすると黒い部分が透明になります。


### 4.2 PNGやGIFなど

背景色を透明にして前景色(文字の部分)を白にすると、
サムネールが真っ白になってなにも表示されなく鳴るので
前景は黒で作った方が良いかもしれません。
その場合、前景色を白に戻すにはScabarに取り込んだ後、
色を反転するオプションを指定してください。

PNG8は透明部分が2値でディザーを使うようなので透明部分が荒くなるので、
PNG24で保存したほうが良いと思います。




## 5 自動バックアップ {#autobackup}

設定と編集中の状態は自動的にバックアップされています。
一度ブラウザを終了しても、次に開いたときに前の状態から再開することができます。

複数のウインドウやタブで作業を行う場合は
File→Envの番号を別なものにしてください。
そうしないと同じ場所にバックアップされてしまいます。

このバックアップデータはブラウザによって勝手に消されることがあります。



## 6 その他 {#tips}

### prescale オプション

画像を開いたときに縮小するサイズです。
'none'にすれば縮小されません。



 


