% プロファイリング

スケールバーの自動生成は
jpegファイル内に含まれているフォーカス情報を元に処理を行います。
その処理のために必要なパラメタを求める作業をプロファイリングと呼んでいます。

コンパクトデジタルカメラの場合機種ごとにプロファイリングを行う必要があります。
フォーサーズ機とマイクロフォーサーズ機はひとまとめにするので、
レンズごとにプロファイリング作業が必要になります。

プロファイリングを行ったらそのデータを
私宛に送っていただければシステムに組み込みたいと思います。
よろしくお願いします。


<div class="toc">
* 1 はじめに

</div>



## 1. はじめに


### 1.0 必要なもの

* パソコン。
 プロファイリングツールはjavascriptで書かれておりブラウザ上で動作しますが、
 大きめのディスプレイとマウスとキーボードの使用を想定しています。
* 三脚
* 高倍率の場合、微動装置(安物で良い)
 ->なくてもいいかも
* 高倍率の場合、スマホ



### 1.1 フォーカス情報の確認

最初に、対象となるカメラで保存したjpegファイルに
フォーカス情報がしまわれているかどうか確認してください。

RAWファイルから現像したものや
画像編集ソフトを通したものは
フォーカス情報が失われているかもしれないので、
カメラが保存したjpegファイルをそのまま使ってください。

#### Scabarで

File -> Image Info. を開き以下の項目が表示されていればOK。

* Focus Step Count

#### Profilerで

読み込んでFSC欄が表示されていればOK。



### 1.1 用語

FOV

: Field Of View の略です。実視野。
 一般的には角度の意味で使われることもありますが、
 Scabarではピントがあっている物体面の矩形の長辺の長さとします。

FOV プロファイル

: フォーカス情報からFOVを求めるためのパラメタです。
 一般用語ではありません。

Focus Step Count

: jpegファイル内に保存されているフォーカス情報です。
 FSCと略します。
 一般用語ではありません。
 編集ソフトなどを通すと失われるので注意してください。

Zoom Step Count

: jpegファイル内に保存されているズーム情報です。
 ZSCと略します。
 一般用語ではありません。
 編集ソフトなどを通すと失われるので注意してください。




## 1.2 作業の流れ

* 基準ゲージ(定規みたいなもの)を用意する
* 撮影距離、ズーム比を変えて写真を撮影する
* 画像ファイルの名前を変更する
* profiler.htmlを起動
* 画像を開く/ドロップ
* 解析開始
* グラフをチェック
* 結果をExport
* Scabarに取り込む




## 2. 基準ゲージ

FOVは長さが既知の物体を撮影することで
求めることができますが、
自動で処理するために
白背景に黒の縦棒が等間隔でならぶパターンを使います。
液晶ディスプレイを使うと
細かいピッチにでき、
精度も高そうですし、大きさも自在にできるし、
ゴミもでないしと具合が良さそうです。
そのためのツールを作ったのでご利用ください。


### 2.1 起動

スマホかパソコンで以下のページを表示してください。
スマホの方がピッチは細かいです。
ノングレア処理されたディスプレイでは
ぼやけて見えるので高倍率の場合は適していません。

<div class="menu">
[基準ゲージ表示ツール(gauge.html)](gauge.html)
</div>

スクリーンショットです。
スクロールすれば全体にパターンが表示されます。
色の付いた線は傾いたりしていないかを確認するためのものです。

![基準ゲージ表示ツール](image/gauge-screen.png)


バグ
ブラウザの表示倍率を変更すると、すぐにはピッチが反映されない。
1 2 ..ボタンを押すと反映される。



### 2.2 動作確認

虫眼鏡等を用いてドット単位で線が描かれているか確認してください。
以下のようになっていれば大丈夫です。

![パターンの拡大図](image/gauge-pattern.jpg)



### 2.3 スクリーンサイズの入力

スクリーンの幅をwの欄にmm単位で入力してください。
どっちが幅かわからない場合もあるかもしれませんが、
自動計算しているhの欄を見て確認してください。



## 3. 撮影


<div class="caution">
**ご注意**
スマホの近くでフラッシュを焚くとスマホにダメージを与えるかもしれません。
フラッシュはオフにしておいたほうが良いと思います。
</div>



撮影距離とズーム倍率を少しずつ変えて基準ゲージを複数枚撮影します。

どのような

撮影距離、ズーム位置、基準ゲージのピッチは
忘れないように記録してください。



* GPS位置情報記録オフにする
 公開される可能性がある場合オフにしてください。
 そうしないと撮影場所が特定されてしまいます。

* 公開用の場合、解像度を少し下げる
 それほど解像度は必要ないので、
   3200x2400 pixel の 圧縮率も標準以下


* アスペクト比
 クロッピングされていない状態にする。
 オリンパスの場合たぶん4:3。
 チェック

* 露出補正 +3〜+7 ぐらい?

* フラッシュをオフ

* FD-1やLD-1を外して標準のリング？に戻す。
 できるだけ最大

* 手ぶれ補正OFF





### ズーム倍率の選択

ズームレンズの場合








### 3.1 撮影モードの選択

ここで撮影モードというのは遠景/マクロのどちらかのことです。
撮影モードが複数ある場合は、それぞれ別にプロファイリングを行ってください。
例えばTG-5の場合、遠景モードとマクロモードで
2回プロファイリングを行い2つのプロファイルデータを作ります。
フォーサーズ機 + 35mm F3.5 Macro では、マクロも遠景も区別はありませんので
1回プロファイリングを行います。

TG-5の場合、A/Pモードが遠景モード、顕微鏡モードがマクロモードです。
顕微鏡モードは4つのサブモード(顕微鏡、 深度合成、 フォーカスBKT、
顕微鏡コントロール(顕微鏡+デジタルズーム))がありますが、
プロファイリングは『顕微鏡』を使ってください。



### 3.1 撮影距離の選択


### ピントリングがあるレンズの場合

ピントリングを等間隔に回す。

無限遠(もしくは最も遠い位置)
1とすると、

 4/4, 3/4, 2/4, 1/4, 0(*)

0は

0が無限遠になる場合は、
0
 1/8あたり


クリック


### ピントリングがない場合

TG-5など









倍率がおおむね等間隔になるように撮影距離を選択してください。

 0.25/n*m,  1/n*m, 2/n*m, .... n*/n*m

 m: 最大倍率
 n: 適当な分割(4〜6ぐらい)



大体で良いので、


インナーフォーカスの場合は、高倍率側を少し細かくしたほうが良さそうです。





ここではレンズ前からゲージまでの距離を撮影距離とします。

倍率の選択


距離をどのように選択するかは自由ですが、

おおむね

最大倍率をMとすると、

等分して
5
 1/16

ような撮影距離





インナーフォーカスの場合は

ズームの場合





#### 単焦点レンズの場合


#### 


 1
 1.4

### 3.2 焦点距離(ズーム倍率)の選択


ピントが合わない場合

最低2点ないとまずい...



### 3.3 基準ゲージの設定

RAW画像から静止したjpegファイルや
編集ソフトを通したjepgeファイルでは
おそらくフォーカス情報が失われると思います。
jpegで撮影した画像をそのまま使ってください。


利用部分は写真の中心部の縦10%、横50%の範囲です。
この範囲に基準ゲージが含まれるようにしてください。

基準ゲージのバーの本数は
少ないと

線幅
画面上部にある1〜32の番号のついたボタンで線幅を指定してください。
撮影画面内に全体に10本から100本ぐらいの線が含まれるようにしてください。





### 3.4 オートフォーカス

単純な繰り返しパターンはオートフォーカスに向かないようです。

TG-5の場合は一度あわせれば大丈夫でしたので、
最初にマニュアルである程度合わせてから


あるいはオートーフォーカスで
ピントがあった位置から少しずつ近づけていくなどすれば
よさそうです。


E-410+35mm Macroでは
(ミラー機)
ではオートフォーカスはつかませんでした。



レンズとゲージの間隔を固定し


ピッチを記録しておいてください。



### 3.5 露出設定

その他
画像の品質

jpeg


絞りはピントが合っているかどうか後で見てわかりやすいので
開放近くが良いと思います。


露出
kkkkkkk
露出補正は+1EVあたりが良さそうでした。


ピント合わせ


シャッター


傾いていないか
2秒タイマー




## 4. ファイル名の変更

 d{num}-m{num}-p{num}-fov{num}-v.{ext}


 d24-m20-p0_125.jpg

{num}の部分には数値を指定します。小数点は'_'に置き換えてください。
 先頭に複数の0を付加してもかまいません。
 e.g. 123, 00123, 0_123


大文字でも小文字でもかまいません。

順序は異なっていてもかまいません。

* d24-z150.jpg
* z150-d24.jpg



prefix

: '-'を含まない任意の文字列です。

-d{num}

: レンズ前からゲージまでの距離を指定します。
 数値に意味はありませんが、順序は保存する必要があります。
 つまりほぼ同じ距離で撮影したものは同じ数値にし、
 距離が長くなるほど大きい数値にしてください。

-z{num}

: ズーム倍率や焦点距離を指定します。
 ズームレンズでない場合は不要です。
 数値に意味はありませんが、順序を保持する必要があります。
 つまり同じ(ほぼ)焦点距離で撮影したものは同じ数値にし、
 望遠側になるほど大きい値にしてください。

-p{num}

: 基準ゲージのピッチをmm単位で正確に指定してください。
 精度は4桁ぐらいあったほうが良いと思います。

-fov{num}

: FOVを指定します。
 自動処理できない場合に使ってください。

-v

: 画像を90度回転してから処理します。
 基準ゲージが縦向きになってしまったときに使ってください。


{ext}

: (jpg|jpeg)
 


## 5. profiler

### 起動

### ファイルの取り込み

### 解析

### グラフ

### export

author

date

description



分類をどうするか

テレコン
 x 1.4とかでいいか。

クローズアップレンズ

 




## 6. Scabarへimport



## 7 共有





 





