#!/usr/bin/perl

# scabar-rename.pl -p pitch -d dist [-v] *.jpg

use strict;


my $pitch;
my $dist;
my $rev;
my $vert;

while( defined(my $a = shift @ARGV) ) {
 if ( $a =~ /^-/ ) {
  if ( $a eq '-p' ) {
   $pitch = shift @ARGV;
  }
  elsif ( $a eq '-d' ) {
   $dist = shift @ARGV;
  }
  elsif ( $a eq '-v' ) {
   $vert = 1;
  }
  elsif ( $a eq '-r' ) {
   $rev = 1;
  }
  else {
   die "ivalid option $a";
  }
 } else {
  unshift @ARGV, $a;
  last;
 }
}

if ( !defined $pitch || !defined $dist ) {
 die "usage scabar-rename.pl -p pitch -d dist *.jpg";
}
$pitch =~ s/\./_/g;

print "$pitch, $dist, $rev, $vert\n";

my @files = @ARGV;
if ( $rev ) {
 @files = reverse(@files);
}

my $count = 0;

for my $file (@files){

 my $newname = "d$dist-p$pitch-z$count";
 if ( $vert ) {
  $newname .= '-vert';
 }
 $newname .= '.jpg';

 print "$file -> $newname\n";
 if ( !rename( $file, $newname ) ) {
  die "$newname: $!";
 }
 $count++;
}

