(function(){
 'use strict';

/*
 TODO:
  アイコンとか。
*/

 let barWidth = 1;
 let barWidthList = [ 1, 2, 4, 8, 16, 32 ];


 function $(id) { return document.getElementById(id); }


 window.addEventListener('load',function(ev){
  $('screenWidth').addEventListener('change',function(ev){
   this.blur();
   onChangeScreenWidth();
  });
  for( let i = 0; i < barWidthList.length; i++ ) {
   let b = barWidthList[i];
   (function(b){
    let el  = $('x'+b);
    el.addEventListener('click',function(ev){
     barWidth = b;
     setHilight();
     dispPattern();
     dispPitch();
    });
   })(b);
  }
  let json = localStorage.getItem('gauge');
  if ( json ) {
   let data = JSON.parse(json);
   if ( data.screenWidth ) {
    $('screenWidth').value = data.screenWidth;
    onChangeScreenWidth();
   }
  }
  window.addEventListener('resize',function(ev){
   onresize();
  });
  setHilight();
  onresize();
 });


 function setTransform(el,transform){
  el.style.transformOrigin = `top left`;
  el.style.WebkitTransformOrigin = `top left`;
  el.style.transform = transform;
  el.style.WebkitTransform = transform;
 }


 function adjustScale(paneId,viewId){
  let pane = $(paneId);
  let view = $(viewId);
  if ( !view.clientWidth || !view.clientHeight ) {
   return;
  }
  let scale = Math.min(
   pane.clientWidth*0.9/view.clientWidth,
   pane.clientHeight*0.9/view.clientHeight
  );
  let x = (pane.clientWidth-scale*view.clientWidth)/2;
  let y = (pane.clientHeight-scale*view.clientHeight)/2;
  setTransform(view,`translate(${x}px,${y}px) scale(${scale})`);
 }


 function onresize(){
  dispPattern();
  adjustScale('buttonArea','buttonView');
  adjustScale('screenSizeArea','screenSizeView');
  adjustScale('pitchArea','pitchView');
 }


 function setHilight(){
  for( let i = 0; i < barWidthList.length; i++ ) {
   let n = barWidthList[i];
   let el = $('x'+n);
   el.className = '';
  }
  let el = $('x'+barWidth);
  el.className = 'hilight';
 }


 function dispPitch(){
  let s = $('screenWidth').value;
  if ( s !== undefined ) {
   let screenWidth = parseFloat(s);
   let precision = 0;
   let p = s.match(/\.(\d+)/);
   if ( p ) {
    precision = p[1].length;
   }
   if ( screenWidth ) {
     // mm
    let devicePixelRatio = window.devicePixelRatio;
    let pitch = barWidth*2*screenWidth
      / (screen.width*window.devicePixelRatio);
    $('pitchValue').value = pitch.toPrecision(5);
    $('screenHeight').value = (screenWidth/screen.width*screen.height)
     .toFixed(precision);
   }
  }
 }


 function onChangeScreenWidth(ev){
  let s = $('screenWidth').value;
  let screenWidth = parseFloat(s);
  if ( screenWidth !== undefined ) {
   let precision = 0;
   let p = s.match(/\.(\d+)/);
   if ( p ) { precision = p[1].length; }
   $('screenHeight').value = (screenWidth/screen.width*screen.height)
    .toFixed(precision);
   dispPitch();
   let key = 'gauge';
   let json = JSON.stringify({ screenWidth: screenWidth });
   localStorage.setItem(key,json);
  }
 }


 function dispPattern(){
  let devicePixelRatio = window.devicePixelRatio;
  let box = $('pattern');
  let width = window.innerWidth * devicePixelRatio;
  let height = window.innerHeight * devicePixelRatio;
  let svg = `<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
    <svg viewBox="0 0 ${width} ${height}"
     width="${width}" height="${height}"
     style="width:${width}px; height:${height}px;"
     xmlns="http://www.w3.org/2000/svg"
     xmlns:xlink="http://www.w3.org/1999/xlink" >`;
  svg += `<g stroke-width="${barWidth}" fill="none" opacity="50" >`;
  for( let i = 0, y = barWidth/2+barWidth;
    y < height; i+=5, y += 5*2*barWidth ) {
   let color = i % 50 == 0? '#F88': i % 10 == 0? '#88F': '#8F8';
   svg += `<path d="M 0 ${y} h ${width}" stroke="${color}" />`;
  }
  svg += '</g>';
  svg += `<g stroke-width="${barWidth}" fill="none" opacity="50" >`;
  for( let i = 0, x = barWidth/2+barWidth;
    x < width; i+=5, x += 5*2*barWidth ) {
   let color = i % 50 == 0? '#F88': i % 10 == 0? '#88F': '#8F8';
   svg += `<path d="M ${x} 0 v ${height}" stroke="${color}" />`;
  }
  svg += '</g>';
  svg += `<g stroke="black" stroke-width="${barWidth}" fill="none" >`;
  for( let x = barWidth/2; x < width; x += 2*barWidth ) {
   svg += `<path d="M ${x} 0 v ${height}" />`;
  }
  svg += '</g>';
  svg += '</svg>';
  box.innerHTML = svg;
  setTransform(box.getElementsByTagName('svg')[0],
   `scale(${1/devicePixelRatio})`);
 }

})();
