(function(){
 'use strict';
 const Ld = sLoader;
 Ld.module('gui-object',function(){

  const Gui = {};
  const SObject = Ld.use('sobject');
  const U       = Ld.use('utility');
  const Cons    = Ld.use('console');
  const Opt     = Ld.use('option');

  const C = Gui.Object = SObject.derive();

// どうしよ
  C.setProperties = function(p){
   Object.assign(this,p);
   this.refresh();
  };

// どうしよ
  C.initialize = function(){ this.refresh(); }

// どうしよ
  C.refresh = function(){};


  C.close = function(){
   this.detatch();
  };


  C.addHandler = function(el,type,handler,capture){
  // もうちょい長い名前
  // _handlerList
   if ( !this._handler ) { this._handler = []; }
   this._handler.push( [ el, type, handler, capture ] );
   el.addEventListener(type,handler,capture);
  };

  // unload時に呼ばれない
  // グローバルにもやらないと...
  C.eraseHandler = function(){
   if ( this._handler ) {
    let list = this._handler;
    for( let i = 0; i < list.length; i++ ) {
     let r = list[i];
     r[0].removeEventListener(r[1],r[2],r[3]);
    }
    this._handler = undefined;
   }
  };




  const CLICK_TIMEOUT = 500;
  const CLICK_THRESHOLD = 4;

// 
  C.atatch = function(){
   this.detatch();
   let el = this.baseElement;
   if ( el ) {
    let obj = this;
    this.addHandler(el      ,'mousedown' ,
         function(ev){obj.Guimousedown(ev);});
    this.addHandler(el      ,'touchstart',
         function(ev){obj.Guimousedown(ev);});
    this.addHandler(el      ,'wheel'     ,
         function(ev){obj.Guiwheel(ev);});
   }
  };

  C.detatch = function(){
   this.GuiTCount = 0;
   if ( this.GuiCT ) {
    clearTimerout(this.GuiCT); this.GuiCT = undefined;
   }
   this.eraseHandler2();
   this.eraseHandler();
  };

  C.screenToInternalCoordinate = function(pos){
   return this.toInternalCoordinate(
    // ->U.screenTo
    U.convertFromScreenCoordinate(this.baseElement,pos)
   );
  };

  C.toInternalCoordinate = function(pos) {
   return pos;
  };

  C.getTouchInfo = function(ev){
   let touches = ev.touches;
   if ( !touches ) { touches = [ev]; }
   if ( touches.length == 0 ) { return undefined; }
   let pos = [];
   let ti = {};
   let n = Math.min(touches.length,2);
   for( let i = 0; i < n; i++ ) {
    pos[i] = this.screenToInternalCoordinate(
     { x:touches[i].clientX, y:touches[i].clientY }
    );
   }
   ti.pos = pos;
   if ( n == 2 ) {
    let a = Math.atan2(pos[1].y-pos[0].y,pos[1].x-pos[0].x);
    ti.center = {
     x:(pos[0].x+pos[1].x)/2, y:(pos[0].y+pos[1].y)/2
    };
    ti.distance = Math.sqrt((pos[1].x-pos[0].x)*(pos[1].x-pos[0].x)
     +(pos[1].y-pos[0].y)*(pos[1].y-pos[0].y));
    ti.angle = a;  // radian
   }
// time, modifierKey
// altKey, ctrlKey, shiftKey
   ti.time = ev.timeStamp;
   return ti;
  };


  const lineHeight = 16;   // tekitou
  const pageHeight = 720;  // tekitou
//  const wheelSpeed = 1;    // -> global parameter M.wheelSpeed

  C.getWheelInfo = function(ev){
   let deltaY = ev.deltaY||0;
   let deltaX = ev.deltaX||0;
   let scale = 1/16384*Opt.wheelSpeed;
   switch(ev.deltaMode){
    case 1: scale *= lineHeight; break;
    case 2: scale *= pageHeight; break;
   }

   return {
    pos:this.screenToInternalCoordinate({x:ev.clientX, y:ev.clientY}),
    deltaX:deltaX*scale, deltaY:deltaY*scale,
    altKey:ev.altKey, ctrlKey:ev.ctrlKey,
    shiftKey:ev.shiftKey, metaKey:ev.metaKey,
   };
  };


//
  C.addHandler2 = function(el,type,handler,capture){
   if ( !this._handler2 ) { this._handler2 = []; }
   this._handler2.push( [ el, type, handler, capture ] );
   el.addEventListener(type,handler,capture);
  };

  C.eraseHandler2 = function(){
   if ( this._handler2 ) {
    let list = this._handler2;
    for( let i = 0; i < list.length; i++ ) {
     let r = list[i];
     r[0].removeEventListener(r[1],r[2],r[3]);
    }
    this._handler2 = undefined;
   }
  };


// touchstart
  C.Guimousedown = function(ev) {
   let touches = ev.touches;
   if ( !touches ) { touches = [ev]; }
   ev.preventDefault();
   ev.stopPropagation();

// 下が終わってから
   if ( touches.length >= 3 ) { return; }

   let obj = this;
   let el = this.baseElement;
   if ( this.GuiTCount == 0 && !this.GuiCT ) {
    this.addHandler2(el      ,'click'     ,
         function(ev){obj.Guiclick(ev);});
    this.addHandler2(document,'mouseup'   ,
         function(ev){obj.Guiglobalmouseup(ev);});
    this.addHandler2(el      ,'touchend'  ,
         function(ev){obj.Guiglobalmouseup(ev);});
           // globalじゃねーぞ
    this.addHandler2(el      ,'dblclick'  ,
         function(ev){obj.Guiclick(ev);});
    this.addHandler2(document,'mousemove' ,
         function(ev){obj.Guiglobalmousemove(ev);});
    this.addHandler2(el      ,'touchmove' ,
         function(ev){obj.Guiglobalmousemove(ev);});

    this.GuiStartPos = { x:touches[0].clientX, y:touches[0].clientY };
// _guiLatTi
    this._guiLastTi =
    this.GuiStartTInfo = this.getTouchInfo(ev);
    if ( this.GuiCT ) { clearTimeout(this.GuiCT); }
    // onclickを拾わないのであればすぐにイベントを発行してもいい。

// イベントの中のtimeを使ったほうがいいかも。
    this.GuiCT = setTimeout(function(){
     obj.GuiCT = undefined;
     obj.GuiTCount = 1;
     if ( obj.ontouch1start ) {
      let ti = obj.GuiStartTInfo;
      ti.time += CLICK_TIMEOUT;
      obj.ontouch1start(ti);
     }
    },CLICK_TIMEOUT);
    if ( this.onmousedown ) {
     this.onmousedown(ev);
    }
   }
   if ( touches.length == 2 ) {
    if ( this.GuiCT ) {
     clearTimeout(this.GuiCT); this.GuiCT = undefined;
     this.GuiTCount = 1;
     if ( this.ontouch1start ) {
// timeは更新しておいた方が良い
      this.ontouch1start(this.GuiStartTInfo);
     }
    }
    if ( this.GuiTCount == 1 ) {
     this.GuiTCount = 2;
     // 変化していなければ良いが... detatchとかされてるとどうなる?
     // maaiiya
     if ( this.ontouch2start ) {
      this.ontouch2start(this.getTouchInfo(ev));
     }
    }
   }
  };


// GuiCT -> GuiClickTimer
  C.Guiglobalmouseup = function(ev) {
   let touches = ev.touches;
   if ( !touches ) { touches = [ev]; }
// 押して無いときには送らない
   if ( this.GuiTCount || this.GuiCT ) {
    ev.preventDefault();
    ev.stopPropagation();

//Cons.log('mouseup',touches.length);
    if ( touches.length >= 2 ) { return; }
    if ( this.GuiTCount == 2 ) {
     this.GuiTCount = 1;
     if ( this.ontouch2end ) {
      this.ontouch2end();
     }
    }
    if ( touches.length <= 1 ) {
      // iphonだと0にもなる
      // touches = []
     this.GuiTCount = 0;
     this.eraseHandler2();
     if ( this.GuiCT ) {
      clearTimeout(this.GuiCT); this.GuiCT = undefined;
      if ( this.onclick ) { this.onclick(this._guiLastTi); }
     } else {
      if ( this.ontouch1end ) { this.ontouch1end(this._guiLastTi); }
     }
    }
   }
  };

// mousemove
  C.Guimousemove = function(ev){
   let touches = ev.touches;
   if ( !touches ) { touches = [ev]; }
   if ( this.onmousemove ) {
    this.onmousemove(this.getTouchInfo(ev));
   }
  };

  C.Guiglobalmousemove = function(ev) {
   let touches = ev.touches;
   if ( !touches ) { touches = [ev]; }
   if ( this.GuiTCount || this.GuiCT ) {
    if ( this.GuiCT &&
      Math.abs(touches[0].clientX - this.GuiStartPos.x) < CLICK_THRESHOLD &&
      Math.abs(touches[0].clientY - this.GuiStartPos.y) < CLICK_THRESHOLD 
    ) {
    } else {
     if ( this.GuiTCount == 0 || this.GuiCT ) {
      if ( this.GuiCT) {
       clearTimeout(this.GuiCT); this.GuiCT = undefined;
      }
      this.GuiTCount = 1;
      if ( this.ontouch1start ) {
       this.ontouch1start(this.GuiStartTInfo);
      }
     }
     this._guiLastTi = this.getTouchInfo(ev);
     if ( this.GuiTCount == 1 ) {
      if ( this.ontouch1move ) {
       this.ontouch1move(this._guiLastTi);
      }
     } else {
// touch2使わない場合は ontouch1move...
      if ( this.ontouch2move ) {
       this.ontouch2move(this._guiLastTi);
      }
     }
    }
   }
  };

  C.Guiclick = function(ev) {
   ev.preventDefault();
   ev.stopPropagation();
  };

  C.Guiwheel = function(ev) {
   if ( this.onwheel ) {
    this.onwheel(this.getWheelInfo(ev));
   }
  };





// 

  C.getValue = function() {
   if ( this._value === undefined ) { this._value = this.default; }
   return this._value;
  };

  C.setValue = function(value) {
   this._value = value;
   this.refresh();
  };

  Object.defineProperty(C,'value',{
   get: function(){ return this.getValue(); },
   set: function(value){ this.setValue(value); },
  });




// これなし!!
  C.onChange = function(value){
   let name = this.name || this._name; //
   if ( this.owner && name ) {
    let e = {};
    e[name] = value;
    this.owner.onChange(e);
   }
  };


// これなし!
  C.correctValue = function(value){ return value; }


  return Gui;

 });


})();
