//
// main.js
//
(function(){
 'use strict';
 const Ld = sLoader;


 Ld.module('main',function(){

//  const M = this.body = {};
  const M = this.body;

  M.main         = main;
  M.setAspectRatio = setAspectRatio;
  M.adjustScale  = adjustScale;
  M.disp         = disp;

  M.pRect        = {x:0,y:0,width:0,height:0};  // pane
  M.cRect        = {x:0,y:0,width:0,height:0,diagonal:0};  // crop
  M.scale        = 1;    // (temp)
  M.screenScale  = 1000; // tmp
  M.cropMode     = false;
  M.imageReady   = false;
  M.presetFonts  = undefined;
  M.foreachLayer = foreachLayer;

  const Cons     = Ld.use('console');
 // ...
  M.log          = Cons.log;
  M.error        = Cons.error;


  const Mp       = Ld.use('mainParam');
  const U        = Ld.use('utility');
  const ExifReader=Ld.use('exifReader');
//  const Fov      = Ld.use('fovOlympus');
  const Fov      = Ld.use('fov');
  const Mn       = Ld.use('menu');
  const Img      = Ld.use('imageLayer');
  const Crop     = Ld.use('cropLayer');
  const Cp       = Ld.use('cropParam');
  const Wm       = Ld.use('wm-text');
  const WmI      = Ld.use('wm-image');
  const Sb       = Ld.use('scaleBar');
  const LpFov    = Ld.use('lp-fov');
  const Icon     = Ld.use('icon');
  const Opt      = Ld.use('option');
  const Om       = Ld.use('option-menu');
  const Save     = Ld.use('save');
  const Mb       = Ld.use('messageBox');
  const Help     = Ld.use('help');
  const View     = Ld.use('view');
  const ImageInfo= Ld.use('imageInfo');
  const fontList = Ld.use('fontList');


// layer
// lp-... zIndex


  let inputHistory = {};


  let viewDirty;

  let viewTool;

//
  const screenEl = document.getElementById('pane');
  M.screenEl = screenEl;
  const paneEl = document.createElement('div');
  U.setStyle(paneEl.style,{
   position:'absolute',
  });
  screenEl.appendChild(paneEl);
  M.paneEl = paneEl;


  const dropScreen = document.getElementById('drop-screen');



  let layerStack = [];






 


  function main() {

   if ( Ld.aborted ) return;

   M.imageReady = false;

   M.log("Scabar ",Ld.appVersion);
   M.log(navigator.userAgent);

//   M.log('devicePixelRation',window.devicePixelRatio);
   

   window.addEventListener('load', function() {
    if ('serviceWorker' in navigator) {
     navigator.serviceWorker.register("service-worker.js")
     .then(registration=>{ registration.update(); })
     .catch(e=>{M.error(e);});;
    }
   });


   loadFontList();
   createLayer();
   createMenu();
   Help.init();
   viewTool = View.create();

   function disable(ev){
    ev.preventDefault();
   }

   window.addEventListener('dragover', disable, false );
   window.addEventListener('drop', disable, false );
   window.addEventListener('dragenter', function(ev) {
    ev.preventDefault();
    showDropScreen();
   }, true );
   dropScreen.addEventListener('dragover', onDragOver, false);
   dropScreen.addEventListener('drop', onDrop, false );
   dropScreen.addEventListener('dragleave', hideDropScreen, false );


   let resizetask;

   function onresize(){
    if ( resizetask ) clearTimeout(resizetask);
    resizetask = setTimeout(function(){
     resizetask = undefined;
     if ( M.pRect.width !== window.innerWidth ||
          M.pRect.height !== window.innerHeight ) {
      onResize();
      Mn.onresize();
      dispImmediately();
     }
     onresize();
    },100);
// 時間をあけないと、iPhoneでおかしくなる。
// 開けてもおかしい
// 表示倍率関連の処理ではM.pRect.widthは取り直すべき
   }

   window.addEventListener('orientationchange',onresize,false);
   window.addEventListener('resize',onresize,false);

   Cons.hide();

   document.getElementById('mainScreen').style.display = 'block';

   window.addEventListener('unload',
    function(ev){
 // save
 //
    },
    false
   );

   Mn.start();

   Mp.environmentCode = M.sessionStorage.getItem('scabar-env-code') || '1';
   restoreSessionStatus();

   onresize();
   autoSaveP(); // start

   Cons.setBackColor(Opt.menuBackColor);


  }


  M.stopLoadingEffect = function(){
   document.getElementById('loadingEffector').style.display = 'none';
  };


  M.startLoadingEffect = function(){
   document.getElementById('loadingEffector').style.display = 'block';
  }


  function showDropScreen(){
   dropScreen.style.display = "block";
  }

  function hideDropScreen(){
   dropScreen.style.display = "none";
  }


  // favicon
  {
   let canvas = document.createElement('canvas');
   let head = document.getElementsByTagName('head')[0];
   
   function addFavicon(size,mobile) {
    let svg = Icon.faviconSvg(size);
    let objurl = U.svgTextToObjectURL(svg);
    U.dataURLToImageP(objurl)
    .then((img)=>{
     canvas.width = img.width;
     canvas.height = img.height;
     let ctx = canvas.getContext('2d');
     ctx.save();
     ctx.drawImage(img,0,0,img.width,img.height);
     ctx.restore();
     let dataURL = canvas.toDataURL("image/png");
     let link = document.createElement('link');
     if ( mobile ) {
      link.rel = 'apple-touch-icon';
     } else {
      link.rel = 'icon';
      link.type = 'image/png';
     }
     link.sizes = size+'x'+size;
     link.href = dataURL;
     head.appendChild(link);
     U.revokeObjectURL(objurl);
    })
    .catch(()=>{
     U.revokeObjectURL(objurl);
    });

   }
   addFavicon(16,false);
   addFavicon(32,false);
   addFavicon(192,false);
   addFavicon(152,true);


   // macOS mask-icon
   U.svgToDataURLP(Icon.maskIcon)
   .then((dataURL)=>{
    let link = document.createElement('link');
    link.rel = 'mask-icon';
    link.href = dataURL;
    link.color = 'blue';
    head.appendChild(link);
   });

  }


  function createLayer(){
   layerStack[0] = Img.create  ('image',0);
   layerStack[1] = Crop.create ('crop' ,8);
   layerStack[2] = LpFov.create('fov'    ,4);

   layerStack[3] = Wm.create   ('wmtext'    ,1);
   layerStack[4] = Sb.create   ('scalebar'    ,2);
   layerStack[5] = WmI.create  ('wmimage'    ,3);
  }


  // foreachLayer(fucntion(layer){
  //   
  // });
  function foreachLayer(func){
   for( let i = 0; i < layerStack.length; i++ ) {
    let layer = layerStack[i];
    if ( layer ) {
     // id
     // index
     func(layer);
    }
   }
  }

  //
  function setAspectRatio(aspectH,aspectV){
   Cp.aspectH = aspectH;
   Cp.aspectV = aspectV;
   let diagonal = U.dist(aspectH,aspectV);
   Cp.diagonal = 1;
   Cp.width  = aspectH/diagonal;
   Cp.height = aspectV/diagonal;
   adjustScale();
  }


  M.viewMin = function(){
   let magnification = 'min';
M.pRect.width = window.innerWidth;
M.pRect.height = window.innerHeight;
   if ( Mp.view.mode == 'preview' ) {
    adjustScale(magnification);
    viewTool.change();
   } else {
    Mp.view.magnification = 'min';
    adjustScale(magnification);
   }
  };


  M.viewFit = function(){
   let magnification = 'fit';
M.pRect.width = window.innerWidth;
M.pRect.height = window.innerHeight;
   if ( Mp.view.mode == 'preview' ) {
    adjustScale(magnification);
    viewTool.change();
   } else {
    Mp.view.magnification = 'fit';
    adjustScale(magnification);
   }
  };



  let doc = window.document;
  let docEl = doc.documentElement; // (html)
  let requestFullScreen =
   docEl.requestFullscreen
   || docEl.mozRequestFullScreen
   || docEl.webkitRequestFullScreen
   || docEl.msRequestFullscreen;
  let cancelFullScreen =
   doc.exitFullscreen
   || doc.mozCancelFullScreen
   || doc.webkitExitFullscreen
   || doc.msExitFullscreen;

  function fullscreenEl() {
   return doc.fullscreenElement
   || doc.mozFullScreenElement
   || doc.webkitFullscreenElement
   || doc.msFullscreenElement;
  }

  M.availableFullScreen = function(){
   return requestFullScreen && cancelFullScreen;
  };

  M.toggleFullScreen = function(){
   if ( M.availableFullScreen() ) {
    if ( !fullscreenEl() ) {
     requestFullScreen.call(docEl);
     Mn.changeFullScreenIcon(true);
    } else {
     cancelFullScreen.call(doc);
     Mn.changeFullScreenIcon(false);
    }
   }
  };


//
  M.cropTranslucent = function(){
   layerStack[1].setTranslucent(true);
  };

  M.cropOpaque = function(){
   layerStack[1].setTranslucent(false);
  };


  /*
   ぐちゃぐちゃになってる

   
     screenScale
     viewScale

     cRect.diagonal = 1000
     Cp.diagonal = 1

     screenScale

  */
  function adjustScale( magnification ){
   const CROP_RECT_PADDING = 5;   // %

   M.pRect.width = window.innerWidth;
   M.pRect.height = window.innerHeight;

   if ( isNaN(Cp.width) ) {
    let aspectH, aspectV;
    // 画像だけあった場合...
    if ( M.imageReady ) {
     aspectH = M.imageWidth; aspectV = M.imageHeight;
    } else {
     aspectH = 1; aspectV = 1;
    }
    Cp.aspectH = aspectH;
    Cp.aspectV = aspectV;
    let diagonal = U.dist(aspectH,aspectV);
    Cp.diagonal = 1;
    Cp.width  = aspectH/diagonal;
    Cp.height = aspectV/diagonal;
   }

   let view = Mp.view;
   if ( !magnification ) {
    magnification = view.magnification;
   }
   let ww = M.pRect.width * (1-CROP_RECT_PADDING*2/100);
   let wh = M.pRect.height * (1-CROP_RECT_PADDING*2/100);
   let viewScale = 1, x = 0, y = 0;
   let screenScale = Math.min(ww,wh);

   switch ( magnification ) {
   
   case 'fit':
    {
     let sx = ww/(Cp.width/Cp.diagonal);
     let sy = wh/(Cp.height/Cp.diagonal);
     let s = Math.min(sx,sy);
     viewScale = s/screenScale;
     view.scale = viewScale;
     view.x = x; view.y = y;
    }
    break;
   case 'min':
    viewScale = 1;
    view.scale = viewScale;
    view.x = x; view.y = y;
    break;
   case 'free':
    viewScale = view.scale;
    x = view.x; y = view.y;
    break;
   }

   let scale = viewScale * screenScale;

// iphone 4sで遅い
// safariは一度ラスタライズしてから拡大/縮小しているようだ。
// 小さくすると高解像度のディスプレイでアラが出る。
// 上もdivじゃなくてsvgにしてみるか。
// viewBoxの大きさをどうするか..
//scale = 200;

   M.scale = scale;
   M.cRect.width = scale*(Cp.width/Cp.diagonal);
   M.cRect.height = scale*(Cp.height/Cp.diagonal);
   M.cRect.diagonal = scale*Cp.diagonal;
   M.cRect.x = (M.pRect.width-M.cRect.width)/2+screenScale*x;
   M.cRect.y = (M.pRect.height-M.cRect.height)/2+screenScale*y;

   M.screenScale = screenScale;

   viewDirty = true;
   M.disp();
  }


  function _adjustScale(){
   let scale = M.scale;
   let x = M.pRect.width/2+M.screenScale*Mp.view.x;
   let y = M.pRect.height/2+M.screenScale*Mp.view.y;

   U.setStyle(paneEl.style,{
    left:(-M.scale*Cp.width/2)+"px", top:(-M.scale*Cp.height/2)+"px",
    width:Cp.width*M.scale+"px", height:Cp.height*M.scale+"px",
    transform: `translate(${x}px,${y}px) `,
   });

   foreachLayer(function(layer){
    if ( layer.onresize ) { layer.onresize(); }
   });
  }


  function dispImmediately(){
   if ( viewDirty ) {
    viewDirty = false;
    _adjustScale();
   }
   foreachLayer(function(layer){
    if ( layer.disp ) { layer.disp(); }
   });
  }

  M.redrawImmediately = function(){
   foreachLayer(function(layer){
    layer.dirty = true;
   });
   dispImmediately();
  };

  // 
  M.redraw = function(){
   foreachLayer(function(layer){
    layer.dirty = true;
   });
   disp();
  }


// 変数は前に!
  let dispSchedule;

  function disp(){
   if ( dispSchedule ) { return; }
   dispSchedule = true;
   requestAnimationFrame(function(timestamp){
    dispImmediately();
    dispSchedule = undefined;
   });
  }



  function onResize(){
   M.pRect.width = window.innerWidth;
   M.pRect.height = window.innerHeight;
   adjustScale();
  }


  function onUnload(){
   M.imageReady = undefined;
 // いろいろクリア
   foreachLayer(function(layer){
    if ( layer.onUnload ) { layer.onUnload(); }
   });
   M.imageReady = false;
   Mn.back(0);
   disp();
  };

let fileMenu = {};

  function createMenu(){
   let mdef = {
    file:
         Mn.CSubmenu.create({priority:100,
          text:'File',
          submenuId:'file',
         }),
    cropping     :
         Mn.CSubmenu.create({priority:70,text:'Crop',
          submenuId: 'crop',
         }),
    layer        :
         Mn.CSubmenu.create({priority:60,text:'Tool',
          submenuId: 'layer',
         }),
    option       : Mn.CSubmenu.create({ priority:40,
         text:'Option', submenuId:'option',
        }),
    help         :
         Mn.CSubmenu.create({priority:20,text:'Info',
          submenuId: 'help',
        }),
   };

   Mn.CMenuDef.create({
    id:'main',
    items: mdef,
   });


   fileMenu.menu = Mn.CMenuDef.create({
    id:'file',
    owner: fileMenu,
    items: {
     environmentCode:
          Mn.CSelect.create({priority:90,
           buttonText:'Env.',
           title: 'Environment',
           cellPadH: 48,
           default: '1',
           list: [
            '1', '2', '3', '4', '5', '6'
           ]
          }),
     open         :
          Mn.button({priority:80,
           text:'Open',
           onclick: onOpenFile
          }),
     save         : 
          Mn.CSubmenu.create({priority:70,text:'Save',
           submenuId: 'save',
          }),
     close        :
          Mn.button({priority:60,
           text:'Close',
           onclick: onCloseFile
          }),
     imageInfo: Mn.button({priority:50,
      text:'Image<br>Info.',
      onclick:function(){ ImageInfo.show(); }
     }),
    }
   });

   fileMenu.onChange = function(values){
    if ( values.environmentCode ) {
     Mp.environmentCode = values.environmentCode;
     restoreSessionStatus();
    }
   };

   fileMenu.restoreSessionStatus = function(data){
    fileMenu.menu.restore(data);
   };

   fileMenu.getSessionStatus = function(){
    return {
     environmentCode: Mp.environmentCode
    };
   };


   Mn.CMenuDef.create({
    id:'layer',
    items: {
     watermark    :
          Mn.CSubmenu.create({priority:60,text:'Water Mark<br>(text)',
           submenuId: 'wmtext',
          }),
     watermark2    :
          Mn.CSubmenu.create({priority:58,text:'Water Mark<br>(image)',
           submenuId: 'wmimage',
          }),
     scalebar     :
          Mn.CSubmenu.create({priority:50,text:'Scale Bar',
           submenuId:'scalebar',
          }),
     measure     :
          Mn.CSubmenu.create({priority:50,text:'FOV',
           submenuId:'fov',
          }),
     }
   });
  }




  let indexedDB = window.indexedDB || window.mozIndexedDB
   || window.webkitIndexedDB || window.msIndexedDB;
  let IDBTransaction = window.IDBTransaction || window.webkitIDBTransaction
   || window.msIDBTransaction;
  let IDBKeyRange = window.IDBKeyRange || window.webkitIDBKeyRange
   || window.msIDBKeyRange

  // 
  const databaseVersion = 1;
  const databaseName = 'scabar';


  let idb;


// あれだな。
  async function dbOpenP() {
   if ( idb === undefined ) {
    idb = await new Promise((resolve, reject) => {
     let request = indexedDB.open(databaseName,databaseVersion);
     request.onerror = ()=>{
      reject(request.errorCode);
     };
     request.onupgradeneeded = ()=>{
      let db = request.result;
      M.log(db.version); // currentVersion?
      let store = db.createObjectStore('table', {keyPath: 'key'});
      let index = store.createIndex('by_key', 'key', {unique: true});
     };
     request.onsuccess = ()=>{
      resolve(request.result);
     };
    });
   }
   return idb;
  }

  
  M.setItemP = async function (key,value) {
   let db = await dbOpenP();
   await new Promise((resolve, reject) => {
    let tx = db.transaction('table', 'readwrite');
    tx.onerror = ()=>{ reject(tx.error); };
    tx.oncomplete = ()=>{ resolve(); };
    let store = tx.objectStore('table');
    let request = store.put({key:key, value:value});
    request.onerror = ()=>{ 
     M.error('setItemP',request.error);
     // 
    };
   });
  };


 // dbOpenは最初に??
  M.getItemP = async function (key) {
   let db = await dbOpenP();
   let tx = db.transaction('table', 'readonly');
   let store = tx.objectStore('table');
   let index = store.index('by_key');
   let request = index.get(key);
   let value = await new Promise((resolve, reject) => {
    tx.onabort = () => { reject(tx.error); };
    request.onerror = () => { reject(request.error); };
    request.onsuccess = ()=>{
     let matching = request.result;
     let value = matching !== undefined? matching.value: null;
     resolve(value);
    };
   });
   return value;
  };


  // iOS Safari standalone mode
  M.sessionStorage = navigator.standalone? localStorage: sessionStorage;


  let lastStatus;

  async function saveSessionStatusP(){
   try{
    let envCode = Mp.environmentCode || '1';
    M.sessionStorage.setItem('scabar-env-code',envCode);
    let data = {};
    data.main = Mp;
    data.option = Opt;
    data.menu = Mn.getSessionStatus();
    data.save = Save.getSessionStatus();
    data.fileMenu = fileMenu.getSessionStatus();
    foreachLayer(function(layer){

// layer.id
     data[layer.id] = layer.getSessionStatus();

    });
    data.inputHistory = inputHistory;
 // data.settings
    let json = JSON.stringify(data);
    if ( !lastStatus || json != lastStatus ) {
     let key = 'session-'+envCode;
     await M.setItemP(key,json);
     lastStatus = json;
    }
   }
   catch(e){ M.error(e); }
  }


  // auto save
  async function autoSaveP(){
   for(;;) {
    await saveSessionStatusP();
    await U.sleepMSP(1000);
   }
  }


  function restoreSessionStatus(){
   (async()=>{
    try{
     M.startLoadingEffect();
     Mn.restoreSessionStatus({});
     M.imageReady = false;
     let profiles;
     let data = {};
     let image, dataURL;

     try{
      let envCode = Mp.environmentCode;
      let key = 'session-'+envCode;
  // まとめたい...
      let json = await M.getItemP(key);
      profiles = await M.getItemP('profiles');

      // getItemP([key1,key2,...])?
      dataURL = await M.getItemP('dataURL-'+envCode);
      if ( dataURL && dataURL != 'undefined' ){
       image = await U.dataURLToImageP(dataURL)
       M.imageReady = true;
      }
      if ( json ) data = JSON.parse(json);
     } 
     catch(e){
      M.error(e);
     }
     if ( data.main ) Object.assign(Mp,data.main);
     Fov.restoreProfiles(profiles);
     Om.restoreSessionStatus(data.option);
     Save.restoreSessionStatus(data.save);
     fileMenu.restoreSessionStatus(data.fileMenu);
     foreachLayer(function(layer){
      layer.restoreSessionStatus(data[layer.id]); 
     });
     if ( image ) {
      foreachLayer(function(layer){
       if ( layer.onLoadImage ) {
        // Mp.exif, Mp.fileName
        layer.onLoadImage(image,dataURL);
       }
      });
     }
     inputHistory = data.inputHistory || {};
     Mn.restoreSessionStatus(data.menu);
    }
    catch(e){
     M.error(e);
    }
    M.stopLoadingEffect();
    onResize();
    M.redraw();

   })();

  }


// optionに?
// 自動保存時はM.logでエラーを出す。
// 手動で保存したときは表にメッセージを出す
  // num: 1, 2, ... , 9
  // 0: default
  /*
   Mpはすべて保存しない
   メニューの状態は保存しない
   Crop.translateは保存しない
  */
  M.saveSetting = function(num){
   // scabar.settings.1
   let key = 'scabar.settings.'+num;
   let data = {};

   let d = new Date();
   data.time = d.toLocaleString();

   data.option = Om.getSetting();
   data.save = Save.getSetting();
   foreachLayer(function(layer){
    data[layer.id] = layer.getSetting();
   });
   let json = JSON.stringify(data);
   try{
    localStorage.setItem(key,json);
   }
   catch(e){
    // エラー表示?
   }
  };


/*
復活するかも
  M.reloadFontList = function(){
   M.presetFonts = Ld.use('fontList').get();
   let json = JSON.stringify(M.presetFonts);
   try{
    localStorage.setItem('scabar.fontList',json);
   }
   catch(e){
    M.error(e);
   }
  };
*/

  function loadFontList(){
   M.presetFonts = fontList.get();
/*
   let json = localStorage.getItem('scabar.fontList');
   if ( !json ) {
    M.reloadFontList();
   }
   else {
    M.presetFonts = JSON.parse(json);
   }
*/
  }


  M.saveProfiles = function(){
   let profiles = Fov.getProfiles();
   M.setItemP('profiles',profiles);
  };


  function prescaleImage(img){
   let prescale = Opt.prescale == 'none'? undefined: parseInt(Opt.prescale);
   let width = img.width;
   let height = img.height;
   let dataURL = img.src;
   if ( prescale ) {
   // いらんか。
    if ( prescale < 960 ) { prescale = 960; }
    if ( prescale > 5760 ) { prescale = 5760; }
    let scale = prescale/U.dist(width,height)
    let canvas = document.createElement('canvas');
    canvas.width = Math.round(width*scale);
    canvas.height = Math.round(height*scale);
    let ctx = canvas.getContext('2d');
    ctx.fillStyle = 'white';
    ctx.fillRect( 0, 0, canvas.width, canvas.height ); // for svg!
    ctx.drawImage( img, 0, 0, canvas.width, canvas.height );
    dataURL = canvas.toDataURL("image/jpeg",0.94);
    width = canvas.width;
    height = canvas.height;
    img = canvas;

    // safariとfirefoxで 画像が出なくなる。
    // よくわからない。
    let dmyimg = new Image;
    dmyimg.onload = function(){
     let dmycanvas = document.createElement('canvas');
     let ctx = dmycanvas.getContext('2d');
     ctx.drawImage( dmyimg, 0, 0 );
     dmyimg = undefined;
    }
    dmyimg.onerror = function(){
     dmyimg = undefined;
    }
    dmyimg.src = dataURL;
   }
   return{
    dataURL: dataURL,
    img: img,
    width: width,
    height: height,
   };
  }


  M.getHFOV = function(){
   // LpHfov
   return layerStack[2].getHFOV();
  };


//!!
const exifOlympus = Ld.use('exif-olympus');

  // 
  function onLoadImage(fname,image,exif){

   // 
   onUnload();

   let prescaledImage = prescaleImage(image);
   let err;

   M.setItemP('dataURL-'+(Mp.environmentCode||'1'),prescaledImage.dataURL)
   .catch(e=>{
    M.error(e);
// クローズ状態にする!!
    Mb.messageBox({
     text:
      `<h2>ERROR: Quota Exceeded Error</h2>
      <p>Image file size is too large (${prescaledImage.dataURL.length}).
       Please try with lower prescale option.</p>`
    });
    err = true;
   });


   Mp.exif = exif;
   Mp.fileName = fname;

   Mp.imageWidth = prescaledImage.width;
   Mp.imageHeight = prescaledImage.height;
   Mp.imageDiagonal = U.dist(Mp.imageWidth,Mp.imageHeight);

   Mp.hfov = undefined;
   exif.ImageWidth = image.width;
   exif.ImageHeight = image.height;
//   let fov = Fov.approximate(exif);


// crop.onOpenImage
   let aspectH = Mp.imageWidth;
   let aspectV = Mp.imageHeight;
   Cp.transform.x = 0;
   Cp.transform.y = 0;
   Cp.transform.zoom = 1;
   Cp.transform.rotation = 0;
   Cp.mirror = false;
   if ( exif.Orientation ) {
    let k = parseInt(exif.Orientation);
    if ( k < 1 || k > 8 ) { k = 1; }
    /*
     1 = Horizontal (normal) 
     2 = Mirror horizontal 
     3 = Rotate 180 
     4 = Mirror vertical 
     5 = Mirror horizontal and rotate 270 CW 
     6 = Rotate 90 CW 
     7 = Mirror horizontal and rotate 90 CW 
     8 = Rotate 270 CW
    */
    //                   1    2    3    4    5    6    7    8
    const MIRROR   = [   0,   1,   0,   1,   1,   0,   1,   0 ];
    const ROTATION = [   0,   0, 180, 180, 270,  90,  90, 270 ];
// -0.5 ~ ???
    Cp.transform.rotation = ROTATION[k-1]/360;
    Cp.mirror   = MIRROR[k-1] != 0;
    if ( k >= 5 ) {
     let t = aspectH; aspectH = aspectV; aspectV = t;
    }
   }
   setAspectRatio(aspectH,aspectV);

   // 
   layerStack[0].onLoadImage(prescaledImage.img,prescaledImage.dataURL);

   foreachLayer(function(layer){
    if ( layer.onOpenImage ) {
     layer.onOpenImage();
    }
   });
   Save.onOpenImage();
   Save.onLoadImage();
    // onOpenImageとonLoadImageは何が違うんだっけ？

   saveSessionStatusP();

   M.imageReady = true;
   M.redraw();

  }


  //
  async function openFileP(f){
   try{
    hideDropScreen();
    M.startLoadingEffect();
    let a = await Promise.all(
      [U.loadImageP(f), ExifReader.readP(f)]);
    let [image,exif] = a;
    M.stopLoadingEffect();
// 展開
    onLoadImage(f.name,image,exif);
   }
   catch(e){
    M.error(e);
    M.stopLoadingEffect();
   }
  }


  // menu
  function onOpenFile(ev){
   (async()=>{
    let files = await U.openFileP({accept:'image/*', name:'files[]'});
    if ( files[0] ) {
     await openFileP(files[0]);
    }
   })();
  }


  function onCloseFile(ev){
   (async()=>{
    try{
     M.startLoadingEffect();
     await M.setItemP('dataURL-'+(Mp.environmentCode||'1'),null);
     await saveSessionStatusP();
    }
    catch(e){
     M.error(e);
    }
    M.stopLoadingEffect();
    M.imageReady = false;
    M.redraw();
   })();
  }


  // drop
  function onDrop(ev) {
   ev.stopPropagation();
   ev.preventDefault();
   hideDropScreen();
   let f = Array.from(ev.dataTransfer.files)
     .find(a=>a.type.match(/image\/*/));
   if ( f ) openFileP(f);
  }


  function onDragOver(ev) {
   ev.stopPropagation();
   ev.preventDefault();
   ev.dataTransfer.dropEffect = 'copy';
  }


  // toggleViewMode
  M.zoom = function(){
   if ( Mp.view.mode == 'edit' ) {
// openとcloseの対象性が無い...
//    viewTool.open();
    Mn.open('view');
   } else {
    Mn.back();
   }
  };


  M.getInputHistory = function(key){
   let list = inputHistory[key];
   if ( list === undefined ) { list = {}; }
   return list;
  };


  M.setInputHistory = function(key,value){
   let oldlist = inputHistory[key];
   if ( oldlist === undefined ) { oldlist = {}; }
   let newlist = [];
   const max = 20;
   newlist.push(value);
   for( let i = 0; i < oldlist.length && newlist.length < max; i++ ) {
    if ( oldlist[i] != value ) {
     newlist.push(oldlist[i]);
    }
   }
   inputHistory[key] = newlist;
  };


 });
})();
