(function(){
 'use strict';
 const Ld = sLoader;


 Ld.module('option-menu',function(){

  const Om = {};

  const M       = Ld.ref('main');
  const Mn      = Ld.use('menu');
  const Opt     = Ld.use('option');
  const Cons    = Ld.use('console');

  let menuDefs = {

   prescale     : Mn.CSelect.create({
     priority:50, title:'Image<br>Prescale',
     default: '3840px',
     list:[ 'none', '5760px', '3840px', '2880px', '1920px' ],
    }),


   // selectに
   menuBackColor    : Mn.CSelect.create({
     priority:20, title:'Menu<br>Back Color', default:'0,0,0',
     list:[
      [ '0,0,0'      , 'black'],
      [ '255,255,255', 'white'],
     ],
    }),

// buttonText省略可能に
   menuContrast : Mn.CSlider.create({
     priority:18, title:'Menu<br>Back Opacity', default:60, min:20, max:100
    }),

   wheelSpeed   : Mn.CSlider.create({
     priority:16, title:'Mouse<br>Wheel Speed',
     curve:'log', min:1/16, max:16, default:1
    }),

   unsharpMask  : Mn.CSelect.create({
     priority:15, title:'Unsharp<br>Mask',
     default:'on',
     list:[
      [ 'on'  , 'ON' ],
      [ 'off' , 'OFF' ],
     ],
    }),

   textDirection: Mn.CSelect.create({
     priority:14, title:'Text<br>Direction',
     default: 'auto',
     list:[
      [ 'auto', 'auto' ],
      [ 'ltr' , '→'   ],
      [ 'rtl' , '←'   ]
     ],
    }),

/*
   reloadFont: Mn.button({
     priority:12, text:'Reload<br>Font List',
     onclick:function(){ M.reloadFontList(); }
    }),
*/

   console       : Mn.button({
     priority:10, text:'Show<br>Console',
     onclick:function(){ Cons.toggle(); }
    }),

  };

  Om.menu = Mn.CMenuDef.create({
   id:'option',
   items:menuDefs,
   owner: Om,
   sig:'Option',
  });



  let saveMenu = {};
  let saveButtons = {};
  for( let i = 0; i < 6; i++ ) {
   (function(num){
    saveButtons[num] = Mn.CMenuButton.create({priority:(6-num),
     text:num,
     onclick:function(){
      M.saveSetting(num);
      Mn.back();
     }
    });
   })(i+1);
  }
  Mn.CMenuDef.create({
   id:'saveSetting',
   items:saveButtons,
   owner:saveMenu,
  });


  // とりあえず日付でもいれておくか。
  function setLoadSaveButton(buttons){
   for( let num = 1; num <= 6; num++ ) {
    let key = 'scabar.settings.'+num;
    let json = localStorage.getItem(key);
    let name = '-';
    if ( json ) {
     let data = JSON.parse(json);
     name = data.time;
    }
    let button = buttons[num];
    button.text = `${num}<br>${name}`;
// setContents(contents)だよな。
    button.setContents();
   }
  }

  saveMenu.onMenuActive = function(){
   setLoadSaveButton(saveButtons);
  };


  let loadMenu = {};
  let loadButtons = {};
  for( let i = 0; i < 6; i++ ) {
   (function(num){
    loadButtons[num] = Mn.CMenuButton.create({priority:(6-num),
     text:num,
     onclick:function(){
      M.loadSetting(num);
      Mn.back();
     }
    });
   })(i+1);
  }
  Mn.CMenuDef.create({
   id:'loadSetting',
   items:loadButtons,
   owner:loadMenu,
  });

  loadMenu.onMenuActive = function(){
   setLoadSaveButton(loadButtons);
  };


  Om.getSetting =
  Om.getSesstionStatus = function(){
   return Opt;
  };

  Om.loadSetting = 
  Om.restoreSessionStatus = function(data){
   Om.menu.restore(data);
   Object.assign(Opt, Om.menu.getValues());
   Mn.changeOption(Opt);
  };

  Om.onChange = function(values){
   Object.assign(Opt,values);

   // menu
   Mn.changeOption(values);
   if ( values.menuBackColor !== undefined ) {
    Cons.setBackColor(values.menBackColor);
   }

  };

  return Om;

 });
})();
