(function(){
 'use strict';
 const Ld = sLoader;
 Ld.module('save',function(){

  const Save = {};
  const M    = Ld.ref('main');
  const U    = Ld.use('utility');
  const Cp   = Ld.use('cropParam');
  const Mn   = Ld.use('menu');
  const Mp   = Ld.use('mainParam');
  const Mb   = Ld.use('messageBox');

  const Img  = Ld.use('imageLayer');


  let fileSizeChanged = false;

// let param
  let saveResize = '';
  let saveQuality = -1;
  let saveWidthPx;
  let saveHeightPx;
  let savePercent;

  Save.values = {};

  const QualityTbl = [
   0.5,
   0.82,
   0.94,
   0.99,
   1
  ];

  Save.mdef = {

   saveImage:
    Mn.CMenuButton.create({priority:100,
     text:'Save<br>Image',
     onclick: saveImage,
    }),

   showImage:
    Mn.CMenuButton.create({priority:100,
     text:'Show<br>Image',
     onclick: showImage,
    }),

   resize:
    Mn.CSelect.create({priority:90,
     title: 'Resize',
     default: '960px',
     list: [
     "none"  ,
     "1920px", "1440px", "960px" , "720px" , "480px" ,
     "100%", "70%" , "50%" , "35%" , "25%" ,
     "500kB", "200kB", "100kB",
     ]
    }),

   quality:
    Mn.CSelect.create({priority:80,
     title: "Quality",
     default: 2,
     // サイズが1/2ずつ小さくなるように選んだ。だいたい。
     list: [
      [ 0, "1 low" ], 
      [ 1, "2 medium" ], 
      [ 2, "3 high" ], 
      [ 3, "4 very high" ], 
      [ 4, "5 maximum" ], 
     ],
    }),


   fileName:
    Mn.CText.create({priority:60,
     title:'File Name',
    }),
  
  /*
   fileSize:
    Mn.CButtonWithValue.create({priority:50,
     text: 'File Size',
     value: '? kB',
    }),
*/
   info:
    Mn.CMenuButton.create({priority:50}),
     
   
  };

  Save.menu = Mn.CMenuDef.create({
   id:'save',
   items: Save.mdef,
   owner: Save,
  });


  async function makeSaveImageP(width,height,qualityCode){
   let canvas = document.createElement('canvas');
   let quality = QualityTbl[qualityCode] || QualityTbl[2];
   canvas.width = width;
   canvas.height = height;
   let diagonal = U.dist(width,height);
   let scale = diagonal;
   let svgText = `<?xml version="1.0" encoding="UTF-8" standalone="no"?>
    <svg viewBox="${0} ${0} ${width} ${height}"
     width="${width}" height="${height}"
     xmlns="http://www.w3.org/2000/svg"
     xmlns:xlink="http://www.w3.org/1999/xlink"
    >
    <g style="isolation:isolate">
   `;
   let cRect = {
    width: width,
    height: height,
    diagonal: U.dist(width,height),
   };
   let p = {
    cRect: cRect
   }
   M.foreachLayer(function(layer){
    svgText += layer.makeSvgText(true,p);
   });
   svgText += '</g></svg>';
   let svgObjectURL = U.svgTextToObjectURL(svgText);
   let dataURL;
   try{
    let img = await U.dataURLToImageP(svgObjectURL);
    let ctx = canvas.getContext('2d');
    ctx.save();
    ctx.fillStyle = "white";
    ctx.fillRect(0,0,width,height);
    ctx.drawImage(img,0,0,img.width,img.height);
    ctx.restore();
    dataURL = canvas.toDataURL("image/jpeg",quality);
   }
   catch(e){ throw(e); }
   finally{ U.revokeObjectURL(svgObjectURL); }
   return dataURL;
  }
  


  // 
  // 処理中排他制御したほうが良いのだろうが...
  // セーブはできないように
  // 編集も...

// 開始時、restoreからは呼ばないようにする。
// 保存しておく!! width, height, sizekb

// 画像ファイルのオープン時も、
// 画像のロードが終わってないと計算できない!!

  // 無理やりな方法!
  async function resizeByFileSizeP(fileSize,quality){
   // fileSize: kB
   let sizeLo, sizekb, width, height;

   // 拡大しない 上限を設定しておく 1440x1080
   let hi = Math.min(Mp.imageDiagonal,U.dist(1440,1080));
   let lo = 0;
    // 小さめに見積もる
    // 960x720 = 100kB , quality0
   let mid = Math.sqrt((960*960+720*720)/(100*Math.pow(2,quality))*fileSize);
   let count = 0;
   for( ; count < 5; count++ ){

    width = Math.round(mid*Cp.width/Cp.diagonal);
    height = Math.round(mid*Cp.height/Cp.diagonal);
    let dataURL = await makeSaveImageP( width, height, quality );

    sizekb = Math.ceil(dataURL.length/4*3/1000);
     // 若干ごみが含まれるので(data:image/jpegの部分)、これより小さくなる
    if ( sizekb <= fileSize && sizekb >= fileSize*0.9 ) {
     break;
    }
    if ( sizekb < fileSize ) {
     if ( mid === hi ) break;
     lo = mid;
     sizeLo = sizekb;
     mid = Math.sqrt(mid*mid/sizekb*fileSize);
     if ( mid >= hi ) mid = hi;
    } else {
     hi = mid;
     mid = Math.sqrt(mid*mid/sizekb*fileSize*0.8);
     if ( mid*mid < (lo*lo + hi*hi)/2 ) {
      mid = Math.sqrt((lo*lo+hi*hi)/2);
     }
    }
   }
   if ( count >= 5 ) {
    if ( lo != 0 ) {
     width = Math.round(lo*Cp.width/Cp.diagonal);
     height = Math.round(lo*Cp.height/Cp.diagonal);
     sizekb = sizeLo;
    } else {
// エラー
     return;
    }
   }
   return [width,height,sizekb];
  }


// onSizeChangeとセットで使うことに...
  function setInfo(){
   makeSaveImageP( saveWidthPx, saveHeightPx, Save.values.quality )
   .then((dataURL)=>{
     let button = Save.mdef.info;
     let sizekb = Math.ceil(dataURL.length/4*3/1000);
     button.text =
      `${saveWidthPx}x${saveHeightPx}<br>`
      +`${savePercent}%<br>`
      +`${sizekb} kB`;
     button.setContents();
   })
   .catch((e)=>{M.error(e);});
  }


 // pixel
  function onSizeChange(){
   // 
   let val = Save.values.resize;
   let quality = Save.values.quality;
   let prescale = Mp.imageWidth/Mp.exif.ImageWidth;

   if ( val == saveResize && quality == saveQuality ) {
    return;
   }
   saveResize = val;
   saveQuality = quality;

//
   let width, height, percent;

   if ( val.match(/kB$/) ) {
    resizeByFileSizeP(parseInt(val),quality)
    .then((a)=>{
     let [width,height,sizekb] = a;
     if ( width !== undefined ) {
      saveWidthPx = width;
      saveHeightPx = height;
      savePercent = Math.round(width/(Mp.imageDiagonal
          *Cp.width)*100*Cp.transform.zoom*prescale);
      let button = Save.mdef.info;
      button.text =
       `${saveWidthPx}x${saveHeightPx}<br>`
       +`${savePercent}%<br>`
       +`${sizekb} kB`;
      button.setContents();
     }
     else {
      let button = Save.mdef.info;
      button.text = 'ERROR';
      button.setContents();
     }
    })
    .catch((e)=>{M.error(e);});
   } else {


   if ( val == 'none' ) {
    // 
    width   = Math.round(Mp.imageDiagonal*Cp.width);
    height  = Math.round(Mp.imageDiagonal*Cp.height);
    percent = Math.round(100*Cp.transform.zoom*prescale);

   } else if ( val.match(/%$/) ) {
    percent = parseInt(val);
    width  = Math.round(Mp.imageDiagonal*Cp.width *percent/
     (100*Cp.transform.zoom*prescale));
    height = Math.round(Mp.imageDiagonal*Cp.height*percent/
     (100*Cp.transform.zoom*prescale));

   } else {
    // pixel
    let pixel = parseInt(val);
    if ( Cp.width > Cp.height ) {
     width = pixel;
     height = Math.round(width*Cp.height/Cp.width);
    } else {
     height = pixel;
     width = Math.round(height*Cp.width/Cp.height);
    }
    percent = Math.round(width/(Mp.imageDiagonal
       *Cp.width)*100*Cp.transform.zoom*prescale);
   }
   if( width < 1 ) { width = 1; }
   if( height < 1 ) { height = 1; }

   saveWidthPx = width;
   saveHeightPx = height;
   savePercent = percent;

   setInfo();
   }
  }


  Save.onChange = function(values){
   Object.assign(Save.values,values);
   if ( values.resize !== undefined || values.quality !== undefined ) {
    onSizeChange();
   }
  };


  Save.onMenuActive = function(){
   onSizeChange();
  };


  // 
  function saveImage(ev){
   makeSaveImageP( saveWidthPx, saveHeightPx, Save.values.quality )
   .then((dataURL)=>{
    let name = Save.values.fileName;
    if ( name == '' ) { name = 'sb'; }
    if ( !name.match(/\.(jpg|jpeg)$/i) ) {
     name += '.jpg';
    }
    if ( navigator.msSaveBlob ) {
     // Edge
     let bin = atob(dataURL.replace(/^[^,]*,/,''));
     let buf = new Uint8Array(bin.length);
     for( let i = 0; i < bin.length; i++ ) {
      buf[i] = bin.charCodeAt(i);
     }
     let blob = new Blob([buf.buffer], { type: 'image/jpeg' });
     navigator.msSaveBlob(blob,name);
    } else {
     // Chrome, Safari(pc), Firefox
     let a = document.createElement('a');
     a.download = name;
     a.href = dataURL;
     let e = document.createEvent("MouseEvents");
     e.initMouseEvent("click", true, true, window,
      0, 0, 0, 0, 0, false, false, false,false, 0, null);
     a.dispatchEvent(e);
    }
   })
   .catch((e)=>{M.error(e);});;
  }


  function showImage(ev){
   makeSaveImageP( saveWidthPx, saveHeightPx, Save.values.quality )
   .then((dataURL)=>{
      
    // messageBoxの幅
    let w = Math.min(window.innerWidth,720)*0.8;
    let scale = w/saveWidthPx;

    Mb.messageBox({title:'Save',
     text:`
<div >
 <img src="${dataURL}" alt="" style="transform-origin:top left; -webkit-transform-origin:top left; transform:scale(${scale}); -webkit-transform:scale(${scale});" />
</div>
`});
   })
   .catch((e)=>{M.error(e);});;

  }


  function onVisible(){
   let saveButton = Save.mdef.saveImage;
//   saveButton.disabled = true;
//   onResizePx();
  }

  Save.onLoadImage = function(){
   let a = Mp.fileName.match(/(.*)\.[^\.]*$/);
   let name;
   if ( a ) {
    name = a[1];
   } else {
    name = Mp.fileName;
   }
   name += "-sb";
   Save.values.fileName = name;
   Save.mdef.fileName.value = name;
   saveResize = '';
   fileSizeChanged = true;
//
  }


  Save.onOpenImage = function(){
   // menu.isActive
   if ( Save.mdef.info.isActive ) {
    saveResize = '';
    onSizeChange();
   }
  }


  Save.getSessionStatus = function(){
   return Save.values;
  };

// 
  Save.restoreSessionStatus = function(data){
   Save.menu.restore(data);
   Object.assign(Save.values,Save.menu.getValues());

// 計算し直す必要があるが、
// 他は揃っているのか？
// Saveボタンが表示されているとき。
//   onSizeChange();
  };

  Save.getSetting = function(){
   return {
    resize: Save.values.resize,
    quality: Save.values.quality,
   };
  };

  Save.loadSetting = function(data){

// チェック
// なければデフォルトに
// px, percent

   Save.menu.restore(data);
   Object.assign(Save.values,Save.menu.getValues());

   onSizeChange();
  };


  return Save;
 });
})();
